#include <stdio.h>
#include <stdlib.h>
#include <stdarg.h>
#include <unistd.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>

#include "extern.h"
#include "defines.h"
#include "config.h"

void open_local_dbs(void) {

	int r=0;

	dbinfo=(struct db_struct *)calloc(sizeof(struct db_struct), 1);

	if (open_local_db(&dbinfo->trapfd, config->file->trap)) r=1;
	if (open_local_db(&dbinfo->rdnsfd, config->file->rdns)) r=1;
	if (open_local_db(&dbinfo->relayfd, config->file->smtp)) r=1;
	if (open_local_db(&dbinfo->proxyfd, config->file->http)) r=1;
	if (open_local_db(&dbinfo->socksfd, config->file->sock)) r=1;
	if (open_local_db(&dbinfo->whitefd, config->file->white)) r=1;
	if (open_local_db(&dbinfo->oklistfd, config->file->oklist)) r=1;

	if (r) {
		cleanup();
		exit(1);
	}

}

void close_local_dbs(void) {

	close(dbinfo->trapfd);
	close(dbinfo->rdnsfd);
	close(dbinfo->relayfd);
	close(dbinfo->proxyfd);
	close(dbinfo->socksfd);
	close(dbinfo->whitefd);
	close(dbinfo->oklistfd);

	free(dbinfo);
	dbinfo=NULL;
}

int open_local_db(int *fd, char *filename) {


	*fd=open(filename, O_CREAT | O_APPEND | O_RDWR, S_IRUSR | S_IWUSR);
	if (*fd<0) {
		fprintf(stderr, "[%s] ", filename);
		perror("Error opening file");
		return -1;
	}
	return 0;

}

int check_incoming(char *ipaddr) {


	





}
